Game rules (1p and MP)
Status:
Category:

Target version:

New Start date:
Redesign

Modding

20%

Description

All the game plugins have a number of cvars that affect how gameplay behaves (either in 1p or MP). Instead/additionally, there
should be a better mechanism for defining the gameplay rules. In this setup, one of the possible rule sets would for example be
"Deathmatch”. "Single player" would be another rule set.

e |t should be easily possible to alter the active set of game rules, or create one's own rule set.
¢ The map cycle should be incorporated into the game rules.
¢ Setting profiles (cf. Renderer Appearance) should/could be incorporated into the game rules somehow?

See: Game rules proposal

Related issues:

Related to Feature #1576:
Related to Feature #1565:
Related to Feature #1457:
Related to Feature #1441:
Related to Feature #1401
Related to Feature #1321:
Related to Feature #1213:
Related to Feature #1202
Related to Feature #1584:
Related to Feature #1484:
Related to Feature #1208:
Related to Feature #1369:
Related to Feature #1386:
Related to Feature #1447:
Related to Feature #1452:
Related to Feature #1498:
Related to Feature #1505:
Related to Feature #1516:
Related to Feature #1581:
Related to Feature #1587:
Related to Feature #1638:

[MP] Option to retain weapons+ammo after death in c...

[MP] Option to remove MP flagged weapons in co-op
[MP] Option to choose items/weapons/ammo on spawn
[MP] Option: weaponstay deathmatch

: [MP] Options for retaining or acquiring items/keys/...

Scoring points in 1p and MP

[MP] Respawn items in co-op and deathmatch

: [MP] Options for Heretic co-op

[Deathkings] Option for monster respawn rate

[MP] Bindings for group chat

Game extension plugins

Dynamic map lists (episode structure)

Stopping monster infighting

Co-op player actions (giving, healing)

[Hexen] Monster respawn rate

[Hexen] Option for ringing the bell from below
[Heretic] Boss drop off physics (never instantly dr...
[Heretic|Hexen] Add Doom-like option for fast monsters
Melee attacks affected by looking up/down

3D weapon behaviour

Configure game options via Shell GUI

Related to Bug #251: [Doom] Nightmare monsters sometimes not fast

Related to Feature #1844:
Related to Feature #2207:
Related to Feature #2238:
Related to Feature #2288:

Support ZDoom's skill definitions in MAPINFO
Fast Monsters option in the Options > Gameplay menu
Configure game rules in custom profiles

Configure all multiplayer game options via GUI

New
New
New
New
New
Rejected
New
New
Closed
Rejected
Rejected
Closed
New
New
Rejected
Rejected
Closed
New
Rejected
New
Closed
Progressed
New
Closed
Closed
New

2012-10-22
2012-06-25
2007-10-04
2007-03-01
2006-03-24
2004-01-07
2003-06-28
2003-06-20
2013-09-03
2009-02-25
2003-06-27
2004-12-15
2005-08-22
2007-05-24
2007-08-27
2009-09-02
2010-01-21
2010-04-13
2012-04-18
2013-09-29
2013-10-24
2005-08-23
2014-07-17
2017-03-04
2017-04-04
2013-10-24

History

#1 - 2013-10-18 15:35 - skyjake

- Description updated

#2 - 2013-10-18 15:53 - skyjake

- Tags changed from Multiplayer to Multiplayer, Gameplay
- Subject changed from [MP] Game rules to Game rules (1p and MP)

- Description updated

#3 - 2013-10-18 15:56 - skyjake
- Priority changed from Normal to High

#4 - 2013-10-18 21:23 - danij

Should a map cycle be incorporated into the game rules?

It occurs to me that a map cycle is outside the scope of a game rule set. A map cycle can and should work independently from a set of game rules.
Mixing the map cycle into the game rules would contradict the map progression that is normally attributed to a singleplayer game session.

#5 - 2013-10-18 21:31 - skyjake

Hmm, in the context of MP it makes more sense than in 1p to have the map cycle as part of rules...

Maybe this could be solved by making the rules hierarchical, so that the map cycle would essentially be a variant applied on a parent rule set? The
rule set hierarchy could also tie into the Game mode hierarchy.

Personally | find it difficult to justify leaving map cycle out of the game rules entirely.

#6 - 2013-10-18 21:46 - danij

Interpreting the rule set as a hierarchy would seem to be the correct solution here. In fact | wonder whether game rules and game modes are actually
the same conceptually and if so then a generalised mechanism which folds both feature sets might be desirable.

However this could potentially mean a rule set is not "complete" with some rules having no defined value.

#7 - 2014-04-12 15:51 - danij

- Target version setto 1.15

#9 - 2014-07-17 17:18 - danij
- Related to Feature #1844: Support ZDoom's skill definitions in MAPINFO added

#10 - 2014-09-15 11:08 - danij
- Target version deleted (1.15)

#11 - 2015-04-22 04:54 - danij
- Assignee set to danij

- Target version set to 42

#12 - 2015-05-03 17:04 - skyjake

- Target version changed from 42 to 2.0 — Home Ul & Packages

#13 - 2015-05-03 17:04 - skyjake

- Target version changed from 2.0 — Home Ul & Packages to Rendering

#14 - 2015-05-03 17:06 - skyjake

- Target version deleted (Rendering)

Removing target version since this is more of an umbrella topic. Issues targeting specific versions should be more concrete in scope.

#15 - 2017-03-04 10:09 - skyjake
- Related to Feature #2207: Fast Monsters option in the Options > Gameplay menu added

#16 - 2017-04-04 08:19 - skyjake

- Related to Feature #2238: Configure game rules in custom profiles added

#17 - 2018-10-27 14:45 - skyjake
- Related to Feature #2288: Configure all multiplayer game options via GUI added
#18 - 2019-11-29 21:32 - skyjake
- Assignee deleted (danij)
- % Done changed from 0 to 20

#19 - 2019-11-29 21:33 - skyjake

- Target version set to Modding
